window.Gleam.initSearch([{"doc":"lustre_omnistate","title":"lustre_omnistate","content":"# Lustre Omnistate\n\n## Use Remote State, Locally\n\n[![Package Version](https://img.shields.io/hexpm/v/lustre_omnistate)](https://hex.pm/packages/lustre_omnistate)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/lustre_omnistate/)\n\n```sh\ngleam add lustre_omnistate@1\n```\n```gleam\nimport lustre_omnistate as lo\n\npub type Msg {\n  // .. rest of your Msg type\n  // add messages shared with the remote\n  SharedMessage(SharedMessage)\n  // recieve new state from the remote\n  OmniMessage(lo.OmniMessage(OmniState, json.DecodeError))\n}\n\n// In your main\nlet #(omniinit, omniupdate) =\n  lo.setup(\n  // \n    init,\n    update,\n    transports.websocket(&quot;WEBSOCKETS_URL&quot;),\n    OmniMessage,\n    encoder_decoder,\n  )\n\nlustre.application(omniinit, omniupdate, view)\n\n// Every time you dispatch a `SharedMessage`, the server will recieve the message\n// and every time the server sends a new state, it&#39;ll dispatch on the client!\n\n// See the `example` folder for a chat app use case\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/lustre_omnistate&gt;.\n\n## Thanks &amp; Acknowledgements\n\n- [kero/lustre_websocket](https://codeberg.org/kero/lustre_websocket)\n\n","url":"index.html"},{"doc":"transports","title":"Transport","content":"pub type Transport(\n  encoded_msg,\n  encoded_omnistate,\n  down_reason,\n  transport_error,\n) {\n  Transport(\n    listen: fn(TransportHandlers(encoded_omnistate)) -&gt; Nil,\n    send: fn(encoded_msg) -&gt; Nil,\n  )\n}\n\nTransport(\n  listen: fn(TransportHandlers(encoded_omnistate)) -&gt; Nil,\n  send: fn(encoded_msg) -&gt; Nil,\n)\n\n\nSynonyms:\ntransports.Transport\ntransports Transport","url":"transports.html#Transport"},{"doc":"transports","title":"TransportHandlers","content":"pub type TransportHandlers(encoded_omnistate) {\n  TransportHandlers(\n    on_up: fn() -&gt; Nil,\n    on_down: fn(Int, String) -&gt; Nil,\n    on_message: fn(encoded_omnistate) -&gt; Nil,\n    on_init_error: fn(String) -&gt; Nil,\n  )\n}\n\nTransportHandlers(\n  on_up: fn() -&gt; Nil,\n  on_down: fn(Int, String) -&gt; Nil,\n  on_message: fn(encoded_omnistate) -&gt; Nil,\n  on_init_error: fn(String) -&gt; Nil,\n)\n\n\nSynonyms:\ntransports.TransportHandlers\ntransports TransportHandlers","url":"transports.html#TransportHandlers"},{"doc":"transports","title":"websocket","content":"pub fn websocket(path: String) -&gt; Transport(String, String, a, b)\n\nSynonyms:\ntransports.websocket\ntransports websocket","url":"transports.html#websocket"},{"doc":"transports","title":"transports","content":"","url":"transports.html"},{"doc":"lustre_omnistate","title":"EncoderDecoder","content":"pub type EncoderDecoder(\n  encoded_omnistate,\n  omnistate,\n  encoded_msg,\n  msg,\n  decode_error,\n) {\n  EncoderDecoder(\n    msg_encoder: fn(msg) -&gt; Result(encoded_msg, Nil),\n    omnistate_decoder: fn(encoded_omnistate) -&gt;\n      Result(omnistate, decode_error),\n  )\n}\n\nEncoderDecoder(\n  msg_encoder: fn(msg) -&gt; Result(encoded_msg, Nil),\n  omnistate_decoder: fn(encoded_omnistate) -&gt;\n    Result(omnistate, decode_error),\n)\n\n\nSynonyms:\nlustre_omnistate.EncoderDecoder\nlustre_omnistate EncoderDecoder","url":"lustre_omnistate.html#EncoderDecoder"},{"doc":"lustre_omnistate","title":"OmniMessage","content":"pub type OmniMessage(omnistate, decode_error) {\n  OmnistateReceived(\n    Result(omnistate, OmnistateError(decode_error)),\n  )\n  TransportUp\n  TransportDown(code: Int, message: String)\n  TransportInitError(message: String)\n}\n\nOmnistateReceived(\n  Result(omnistate, OmnistateError(decode_error)),\n)\n\n\nTransportUp\n\n\nTransportDown(code: Int, message: String)\n\n\nTransportInitError(message: String)\n\n\nSynonyms:\nlustre_omnistate.OmniMessage\nlustre_omnistate OmniMessage","url":"lustre_omnistate.html#OmniMessage"},{"doc":"lustre_omnistate","title":"OmnistateError","content":"pub type OmnistateError(decode_error) {\n  DecodeErrors(decode_error)\n}\n\nDecodeErrors(decode_error)\n\n\nSynonyms:\nlustre_omnistate.OmnistateError\nlustre_omnistate OmnistateError","url":"lustre_omnistate.html#OmnistateError"},{"doc":"lustre_omnistate","title":"setup","content":"pub fn setup(\n  init: fn(a) -&gt; #(b, Effect(c)),\n  update: fn(d, e) -&gt; #(d, Effect(e)),\n  transport: Transport(f, g, h, i),\n  wrapper: fn(OmniMessage(j, k)) -&gt; c,\n  encoder_decoder: EncoderDecoder(g, j, f, e, k),\n) -&gt; #(fn(a) -&gt; #(b, Effect(c)), fn(d, e) -&gt; #(d, Effect(e)))\n\nSynonyms:\nlustre_omnistate.setup\nlustre_omnistate setup","url":"lustre_omnistate.html#setup"},{"doc":"lustre_omnistate","title":"lustre_omnistate","content":"","url":"lustre_omnistate.html"}]);